<h1 align="center">GarbageBot</h1>

<p align="center">
<a href="https://git.end-play.xyz/GarbageReminder/TelegramBot/src/branch/master/LICENSE"><img alt="License: GPL" src="https://img.shields.io/badge/License-GPL-blue"></a>
<a href="https://git.end-play.xyz/GarbageReminder/TelegramBot"><img alt="Code style: black" src="https://img.shields.io/badge/code%20style-black-000000.svg"></a>
</p>  

This bot reminds you about garbage collection for the location of your choice.

## Dependencies

* [Python 3.8+](https://www.python.org) (3.11 is recommended)
* [MongoDB](https://www.mongodb.com)  

Use [MongoDB's installation manual](https://www.mongodb.com/docs/manual/installation).

## Installation

To make this bot run at first you need to have a Python interpreter, MongoDB and optionally git (if you want to update using `git pull`). You can also ignore git and simply download source code, should also work fine. After that you're ready to go.  

> In this README I assume that you're using default python in your
> system and your system's PATH contains it. If your default python
> is `python3` or for example `/home/user/.local/bin/python3.9` - use it instead.

1. Install MongoDB:

    * Install MongoDB by following [official installation manual](https://www.mongodb.com/docs/manual/installation)

2. Download the bot:  

    1. `git clone -b dev https://git.end-play.xyz/GarbageReminder/TelegramBot.git` (if you're using git)
    2. `cd TelegramBot`

3. Create virtual environment [Recommended]:

    1. Install virtualenv module: `pip install virtualenv`
    2. Create venv: `python -m venv .venv`
    3. Activate it using `source .venv/bin/activate` on Linux, `.venv\Scripts\activate.bat` in CMD or `.venv\Scripts\Activate.ps1` in PowerShell.

4. Install project's dependencies:  

    `python -m pip install -r requirements.txt`  
    Without installing those - bot cannot work at all.

5. Configure required keys with your favorite text editor:  

    1. Copy config file: `cp config_example.json config.json`
    2. Open `config.json` using your favorite text editor. For example `nano config.json`, but you can also edit it with vim, mcedit, or Notepad/Notepad++ on Windows
    3. Change `"bot.owner"`, `"bot.api_id"`, `"bot.api_hash"` and `"bot.bot_token"` keys' values.  

    If you don't know where to find bot_token and your id - here you can find some hints: [get bot token](https://www.siteguarding.com/en/how-to-get-telegram-bot-api-token), [get your id](https://www.alphr.com/telegram-find-user-id), [get api_hash and api_id](https://core.telegram.org/api/obtaining_api_id).  

6. Configure database and API:  

    * Configure database:
        1. Change database host and port in keys `"database.host"` and `"database.port"`. For default local installation those will be `127.0.0.1` and `27017` respectively
        2. Change database name to the one you like in `"database.name"`. It will be automatically created on start
        3. If you've changed user and password to access the db, you should also change `"database.user"` and `"database.password"` keys, otherwise leave them `null` (default).

7. Good to go, run it!  

    Make sure MongoDB is running and use `python main.py` to start the bot.

If you need any further instructions on how to configure your bot or you had any difficulties doing so - please use [wiki in this repository](https://git.end-play.xyz/GarbageReminder/TelegramBot/wiki) to get more detailed instructions.  

## Localization

Bot is capable of using custom locales. There are some that are pre-installed (English, German and Ukrainian), however you can add your own locales too. Both locally and by contributing on our [Weblate](https://weblate.end-play.xyz/projects/garbagereminder/telegrambot).  

All localization files are located in the `locale`. Just copy locale file of your choice, name it in accordance to [IETF language tags](https://en.wikipedia.org/wiki/IETF_language_tag) (if you want your locale to be compatible with Telegram's locales) or define your own name. Save it as json and you're good to go. If you want to change default locale for messages - edit `"locale"` parameter in the `config.json`.  

We recommend to only make changes to your custom locale. Or at least always have your backup of for example `en.json` as your fallback.
